<?php
require('../common.php');
if ( $argc < 2 )   die();

for ( $i=1; $i < $argc; $i++ )
{
	$fp  = fopen( $argv[$i], "rb" );
	$tim = fopen( $argv[$i].".tim", "wb" );
	if ( !$fp || !$tim )  die();

	$clut_icns = array();
	$clut_sprs = array();
	for ( $i=0; $i < 16; $i++ )
		$clut_icns[$i] = copyclut( $fp, 0xb000+($i*0x20), 16 );
	for ( $i=0; $i < (8*6); $i++ )
		$clut_sprs[$i] = copyclut( $fp, 0xb200+($i*0x20), 16 );

	fwint4b( $tim, 0x10    ); // TIM ID Tag
	fwint4b( $tim, 0x2     ); // 16 BPP
	fwint4b( $tim, (0xb000*2)+12 ); // Image Data Size
	fwint4b( $tim, 0       ); // Image Org
	fwint4b( $tim, (0xb0*2<<16)+0x100 ); // Image Size

	rewind($fp);
	printf("--- SPR ---\n");
	for ( $i=0; $i < 0xa800; $i++ )
	{
		// POS 0xbf8 = CLUT 0+7
		// POS 0x1c00 = CLUT 8+0
		// POS 0x1c10 = CLUT 8+1
		// POS 0x2000 = CLUT 8+0
		// POS 0x2010 = CLUT 8+1
		$t1 = $i / 0x1c00;
		$t2 = $i % 0x80;
		$clut_n = ((int)$t1*8) + ((int)$t2/0x10);
		//printf("%x = %d ( %d , %d )\n", $i, $clut_n, $t1, $t2);

		$t  = ord( fread($fp, 1) );
		$t1 = ($t >> 0) & 0xf;
		$t2 = ($t >> 4) & 0xf;
		fwrite( $tim, $clut_sprs[ $clut_n ][ $t1 ][0] );
		fwrite( $tim, $clut_sprs[ $clut_n ][ $t1 ][1] );
		fwrite( $tim, $clut_sprs[ $clut_n ][ $t2 ][0] );
		fwrite( $tim, $clut_sprs[ $clut_n ][ $t2 ][1] );
	}
	printf("--- ICN ---\n");
	for ( $i=0; $i < 0x800; $i++ )
	{
		$t2 = $i % 0x80;
		$clut_n = (int)$t2 / 8;
		//printf("%x = %d ( %d )\n", $i, $clut_n, $t2);

		$t  = ord( fread($fp, 1) );
		$t1 = ($t >> 0) & 0xf;
		$t2 = ($t >> 4) & 0xf;
		fwrite( $tim, $clut_icns[ $clut_n ][ $t1 ][0] );
		fwrite( $tim, $clut_icns[ $clut_n ][ $t1 ][1] );
		fwrite( $tim, $clut_icns[ $clut_n ][ $t2 ][0] );
		fwrite( $tim, $clut_icns[ $clut_n ][ $t2 ][1] );
	}

	fclose($fp);
	fclose($tim);
}
